//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  DimGray
#property indicator_color2  DeepSkyBlue
#property indicator_color3  PaleVioletRed
#property indicator_style1  STYLE_DOT

//
//
//
//
//

extern int    Length          = 21;
extern int    Mode            = MODE_EMA;
extern int    Price           = PRICE_CLOSE;
extern double BandsMultiplier = 1.0;

double mid[];
double up[];
double dn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,mid); 
   SetIndexBuffer(1,up); 
   SetIndexBuffer(2,dn); 
   return(0);
}

//
//
//
//
//

double work[][2];

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double error  = iStdError(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,i);
             mid[i] = iMA(NULL,0,Length,0,Mode,Price,i);
             up[i]  = mid[i]+BandsMultiplier*error;
             dn[i]  = mid[i]-BandsMultiplier*error;
   }
   return(0);           
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workErr[];
double iStdError(double price, int period, int r)
{
   if (ArraySize(workErr)!=Bars) ArrayResize(workErr,Bars);  r = Bars-r-1; workErr[r] = price;
                        
      //
      //
      //
      //
      //
                  
      double avgx  = period * (period-1) * 0.5 / period;
      double avgy  = workErr[r]; for (int j=1; j<period && (r-j)>=0; j++) avgy += workErr[r-j]; avgy /= j;
      double sumdx = 0, sumdy = 0, sumdxdy = 0;
  
         for (int k=0; k<period; k++)
         {
            double dx = k-avgx;
            double dy = workErr[r-k]-avgy;
               sumdx    += (dx*dx);
               sumdy    += (dy*dy);
               sumdxdy  += (dx*dy);
         }
         double err = (sumdy-(sumdxdy*sumdxdy)/sumdx)/(period-2); 

         if (err > 0)
               return(MathSqrt(err));
         else  return(0.00);       
}